using Microsoft.AspNet.Authorization;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Benday.AspCore.MsftAuthSample.Security
{
    public class AwesomenessHandler : AuthorizationHandler<AwesomenessRequirement>
    {
        
        protected override void Handle(
            AuthorizationContext context, 
            AwesomenessRequirement requirement)
        {
            var claimType = "Awesomeness";

            if (!context.User.HasClaim(c => c.Type == claimType))
            {
                return;
            }

            var awesomenessValue = 
                Convert.ToInt32(context.User.FindFirst(
                    c => c.Type == claimType).Value);

            if (awesomenessValue >= requirement.MinimumAwesomness)
            {
                context.Succeed(requirement);
            }
        }
    }
}
